// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/openshift/api/config/v1"
	scheme "github.com/openshift/client-go/config/clientset/versioned/scheme"
	meta_v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// SchedulingsGetter has a method to return a SchedulingInterface.
// A group's client should implement this interface.
type SchedulingsGetter interface {
	Schedulings() SchedulingInterface
}

// SchedulingInterface has methods to work with Scheduling resources.
type SchedulingInterface interface {
	Create(*v1.Scheduling) (*v1.Scheduling, error)
	Update(*v1.Scheduling) (*v1.Scheduling, error)
	UpdateStatus(*v1.Scheduling) (*v1.Scheduling, error)
	Delete(name string, options *meta_v1.DeleteOptions) error
	DeleteCollection(options *meta_v1.DeleteOptions, listOptions meta_v1.ListOptions) error
	Get(name string, options meta_v1.GetOptions) (*v1.Scheduling, error)
	List(opts meta_v1.ListOptions) (*v1.SchedulingList, error)
	Watch(opts meta_v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.Scheduling, err error)
	SchedulingExpansion
}

// schedulings implements SchedulingInterface
type schedulings struct {
	client rest.Interface
}

// newSchedulings returns a Schedulings
func newSchedulings(c *ConfigV1Client) *schedulings {
	return &schedulings{
		client: c.RESTClient(),
	}
}

// Get takes name of the scheduling, and returns the corresponding scheduling object, and an error if there is any.
func (c *schedulings) Get(name string, options meta_v1.GetOptions) (result *v1.Scheduling, err error) {
	result = &v1.Scheduling{}
	err = c.client.Get().
		Resource("schedulings").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Schedulings that match those selectors.
func (c *schedulings) List(opts meta_v1.ListOptions) (result *v1.SchedulingList, err error) {
	result = &v1.SchedulingList{}
	err = c.client.Get().
		Resource("schedulings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested schedulings.
func (c *schedulings) Watch(opts meta_v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Resource("schedulings").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a scheduling and creates it.  Returns the server's representation of the scheduling, and an error, if there is any.
func (c *schedulings) Create(scheduling *v1.Scheduling) (result *v1.Scheduling, err error) {
	result = &v1.Scheduling{}
	err = c.client.Post().
		Resource("schedulings").
		Body(scheduling).
		Do().
		Into(result)
	return
}

// Update takes the representation of a scheduling and updates it. Returns the server's representation of the scheduling, and an error, if there is any.
func (c *schedulings) Update(scheduling *v1.Scheduling) (result *v1.Scheduling, err error) {
	result = &v1.Scheduling{}
	err = c.client.Put().
		Resource("schedulings").
		Name(scheduling.Name).
		Body(scheduling).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *schedulings) UpdateStatus(scheduling *v1.Scheduling) (result *v1.Scheduling, err error) {
	result = &v1.Scheduling{}
	err = c.client.Put().
		Resource("schedulings").
		Name(scheduling.Name).
		SubResource("status").
		Body(scheduling).
		Do().
		Into(result)
	return
}

// Delete takes name of the scheduling and deletes it. Returns an error if one occurs.
func (c *schedulings) Delete(name string, options *meta_v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("schedulings").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *schedulings) DeleteCollection(options *meta_v1.DeleteOptions, listOptions meta_v1.ListOptions) error {
	return c.client.Delete().
		Resource("schedulings").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched scheduling.
func (c *schedulings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.Scheduling, err error) {
	result = &v1.Scheduling{}
	err = c.client.Patch(pt).
		Resource("schedulings").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
